﻿/*******************************

	Minimy - Premium WordPress Gallery (version 1.0)
	Copyright (c) 2011 Ruben Bristian
	http://www.rubenbristian.com/wp-plugins/minimy-gallery/
	
	Licensed under the REGULAR ENVATO LICENSING TERMS
	http://codecanyon.net/wiki/support/legal-terms/licensing-terms/
	
	The Regular License grants you, the Purchaser a non-exclusive, non-transferrable right to make use of the work that you acquire in a single application. If you wish to use the work in more than one project, you have to buy a license for each project.

	Any and all use of this script must be accompanied by this copyright/license notice in its present form.
	
********************************

	INCLUDED > Kwicks for jQuery (version 1.5.1)
	Copyright (c) 2008 Jeremy Martin
	http://www.jeremymartin.name/projects.php?project=kwicks
	
	Licensed under the MIT license:
	http://www.opensource.org/licenses/mit-license.php

	Any and all use of this script must be accompanied by this copyright/license notice in its present form.
	
********************************

	INCLUDED > jQuery Easing v1.3 - http://gsgd.co.uk/sandbox/jquery/easing/
	Uses the built in easing capabilities added In jQuery 1.1 to offer multiple easing options
	Copyright &copy; 2008 George McGinley Smith
	All rights reserved.
	
*********************************/

(function($){

	$.fn.minimy = function(options) {
	
		var defaults = {
			slideshowEnabled:true,
			slideshowOn:true,
			slideshowTimer:5000,
			thumbsEnabled:true,
			captionsEnabled:true,
			imageResize:true,
			imgsPath:''
		};
		
		var o = $.extend(defaults, options);
		
		//delare variables
		var tOnLast, gLength, gPages, gIndex=0, gPage=0, tS, lS, oF, loadingT, showT, showOn, eM=true, eS=true;
		
		//cache selectors
		var $g=$(this), $html=$('html'), $body=$('body'), $gThumbsList=$g.find('ul'), $gThumbs=$gThumbsList.find('li img'), $bScrollNext=$g.find('a.minimy-scroll-next'), $bScrollPrev=$g.find('a.minimy-scroll-prev');
		
		//define more variables for selectors(to be cached later)
		var $w, $box, $bPrev, $bNext, $bClose, $bPlay, $bPause, $showControls, $showAnim, $imgFrame, $imgHolder, $imgPreloader, $imgZoom, $imgLarge, $imgLargeHolder, $imgBlack, $iPlus, $iMinus, $boxBackground, $boxMenu, $boxText, $boxThumbsList, $boxThumbs;
		
		//remove thumbs hover class
		if(!($.browser.msie && ($.browser.version == '8.0' || $.browser.version == '8'))){
			$gThumbsList.removeClass('removeHover');
		}
		
		$('a.minimy-a').click(function(){
			openLightBox($('#'+$(this).attr('data-gallery')).find('a').eq(0).find('img'));
			return false;
		});
		
		//get thumb width & thumbs number per page
		if($gThumbs[0].complete){
			continueCreation();
		} else {
			$gThumbs.eq(0).bind('load', continueCreation);
		}
		
		var boxStructure, showAll, noArrows, thumbsStructure;
		//function that continues the creation of a gallery, once the size is determined
		function continueCreation(){
		
			o.thumbsWidth = $gThumbs[0].width+1;
			if($g.find('img.minimy-icon').css('display')=='none'){
				o.thumbsPerPage = Math.floor($gThumbsList.width()/o.thumbsWidth);
			} else {
				o.thumbsPerPage = Math.floor(($gThumbsList.width()-o.thumbsWidth)/o.thumbsWidth);
			}
			
			gLength=$gThumbsList.children().length;
			gPages=Math.ceil(gLength/o.thumbsPerPage);
			gLength%o.thumbsPerPage==0 ? tOnLast=o.thumbsPerPage : tOnLast=gLength%o.thumbsPerPage;
			
			//create minimy-thumbs structure and position thumbnails
			showAll=$g.hasClass('show-all');
			noArrows=$gThumbsList.hasClass('no-arrows');
			thumbsStructure = '<ul id="minimy-thumbs">';
			for(i=0; i<gLength; i++){
				if(!showAll){
					if(!noArrows){
						$gThumbsList.children().eq(i).css('float', 'none').css('margin-top', 0).css('position', 'absolute').css('top', 0).css('left', i*o.thumbsWidth);
					}
				}
				thumbsStructure+='<li><a href="#"><img src="'+$gThumbsList.children().eq(i).attr('data-thumb')+'" /></a></li>';
			}
			thumbsStructure+='</ul>';
			
			//create lightbox structure
			boxStructure = '<div id="minimy"><div id="minimy-lightbox"><div id="minimy-background"></div><div id="minimy-text"></div><div id="minimy-menu">';
			if(o.thumbsEnabled){
				boxStructure += thumbsStructure;
			}
			boxStructure += '<ul id="minimy-buttons"><li><a id="minimy-prev-btn" href="#">Previous</a></li><li><a id="minimy-close-btn" href="#">Close</a></li><li><a id="minimy-next-btn" href="#">Next</a></li><li id="minimy-play"><div></div><a id="minimy-play-btn" href="#">Play</a><a id="minimy-pause-btn" href="#">Pause</a></li></ul></div><div id="minimy-holder" class="zeroAlign"><div id="minimy-preloader"></div></div><div id="minimy-large"></div></div></div>';
			
		}
		
		//add thumbs mouse events
		$gThumbsList.find('a').unbind().mouseover(function(){
			$(this).eq(0).animate({'opacity': '0'}, 150);
			return false;
		}).mouseleave(function(){
			$(this).animate({'opacity': '1'}, 150);
			return false;
		}).click(function(){
			openLightBox($(this).children());
			return false;
		});
		
		//add scroll buttons mouse events
		$bScrollNext.click(function(){
			scrollNext();
			return false;
		}).mouseover(function(){
			$(this).find('img').attr('src', o.imgsPath+'images/next3.png');
			return false;
		}).mouseleave(function(){
			$(this).find('img').attr('src', o.imgsPath+'images/next1.png');
			return false;
		});
		
		$bScrollPrev.click(function(){
			scrollPrev();
			return false;
		}).mouseover(function(){
			$(this).find('img').attr('src', o.imgsPath+'images/prev3.png');
			return false;
		}).mouseleave(function(){
			$(this).find('img').attr('src', o.imgsPath+'images/prev1.png');
			return false;
		});
		
		//function that opens the lightbox, when a thumbnail is pressed
		function openLightBox($thumb){
		
			eM=true;
			oF=$html.css('overflow');
			$html.css('overflow', 'hidden');
			$body.append(boxStructure);
				
			//cache more selectors
			$w=$(window);
			$box=$('#minimy-lightbox');
			$bPrev=$box.find('#minimy-prev-btn');
			$bNext=$box.find('#minimy-next-btn');
 			$bClose=$box.find('#minimy-close-btn');
			$bPlay=$box.find('#minimy-play-btn');
			$bPause=$box.find('#minimy-pause-btn');
			$showControls=$box.find('#minimy-play');
			$showAnim=$showControls.find('div');
			$imgFrame=$box.find('#minimy-holder');
			$imgPreloader=$box.find('#minimy-preloader');
			$imgZoom=$box.find('#minimy-zoom');
			$imgLarge=$box.find('#minimy-large');
			$imgBlack=$box.find('#minimy-black');
			$iPlus=$box.find('#minimy-plus');
			$iMinus=$box.find('#minimy-minus');
			$boxBackground=$box.find('#minimy-background');
			$boxMenu=$box.find('#minimy-menu');
			$boxText=$box.find('#minimy-text');
			
			//position menu(margins)
			var menuMargins=-103;
			if(o.slideshowEnabled){
				menuMargins-=33;
			}
			if(o.thumbsEnabled){
				menuMargins-=8*gLength+41;
				$showControls.attr('style', 'margin-left:'+(gLength*8+35)+'px !important');
			}
			$boxMenu.css('margin-left', menuMargins/2);
		
			//get scroll values
			tS=$w.scrollTop();
			lS=$w.scrollLeft();
		
			//add control(lightbox menu) buttons mouse events
			$bNext.click(function(){
				if(eM){
					nextImage();
				}
				return false;
			}).mouseover(function(){
				$(this).find('img').attr('src', o.imgsPath+'images/next4.png');
				return false;
			}).mouseleave(function(){
				$(this).find('img').attr('src', o.imgsPath+'images/next2.png');
				return false;
			});
			
			$bPrev.click(function(){
				if(eM){
					prevImage();
				}
				return false;
			}).mouseover(function(){
				$(this).find('img').attr('src', o.imgsPath+'images/prev4.png');
				return false;
			}).mouseleave(function(){
				$(this).find('img').attr('src', o.imgsPath+'images/prev2.png');
				return false;
			});
			
			$bClose.click(function(){
				closeLightBox();
				return false;
			}).mouseover(function(){
				$(this).find('img').attr('src', o.imgsPath+'images/close3.png');
				return false;
			}).mouseleave(function(){
				$(this).find('img').attr('src', o.imgsPath+'images/close2.png');
				return false;
			});
			
			$bPause.click(function(){
				pauseSlideshow();
				return false;
			});
			
			$bPlay.click(function(){
				playSlideshow();
				return false;
			}).mouseover(function(){
				$(this).find('img').attr('src', o.imgsPath+'images/play2.png');
				return false;
			}).mouseout(function(){
				$(this).find('img').attr('src', o.imgsPath+'images/play.png');
				return false;
			});
			
			//add key listeners
			$(document).keydown(function(e){
				if(e.keyCode == 39){
					if(eM){
						nextImage();
					}
				}else if(e.keyCode == 37){
					if(eM){
						prevImage();
					}
				}else if(e.keyCode == 27){
					closeLightBox();
				}else if((e.keyCode == 0 || e.keyCode == 32) && o.slideshowEnabled){
					if(showOn){
						pauseSlideshow();
					}else{
						playSlideshow();
					}
				}
			});
			
			//check slideshow
			showOn=o.slideshowOn;
			if(!o.slideshowEnabled){
				$showControls.remove();
				showOn=false;
			}else if(!showOn){
				$bPause.hide();
			}else if(showOn){
				$bPlay.hide();
			}
			
			//position image holder
			$imgFrame.css('top', ($(window).height()-360)/2).css('left', ($(window).width()-480)/2);
		
			//animate everything "in"
			$boxBackground.animate({height:'100%'},300,'easeInQuart');
			$imgFrame.delay(250).animate({height:'360px'},250,'easeInQuart');
			$boxMenu.delay(250).fadeIn();
			
			gIndex=$thumb.parent().parent().index();

			//set proper text
			if(o.captionsEnabled){
				changeText();
			}
			
			if(o.thumbsEnabled){
				$boxThumbsList=$('#minimy-thumbs');
				$boxThumbs=$boxThumbsList.children('li');
			
				//setup minimy thumbs accordion
				kwicks({
					defaultKwick: gIndex
				});
				
				if(!o.slideshowEnabled){
					$boxThumbsList.addClass('thumbs-dummy-border');
				}
			}
			
			//load image
			var path=$thumb.parent().attr('href').toString();
			
			$imgPreloader.delay(400).fadeIn('fast');
			loadingT = setTimeout(function(){loadImage(path)}, 400);
			
			//bind window resize event
			$(window).resize(function() {
				resizeStage();
			});
		
		}
		
		var imageLoading = false;
		var globalImage = null;
		var tH, tW;
		function loadImage(path){
		
			var img = new Image();
		
			imageLoading = true;
			globalImage = img;
		
			$(img).load(function(){
			
				imageLoading = false;
				globalImage = null;
				
				$(this).hide();
				$imgFrame.append(this);
				$(this).addClass('imgObj');
				
				//cache loaded image selector
				$imgHolder=$imgFrame.find('img.imgObj');
				
				tW=$(this).width();
				tH=$(this).height();
				
				$imgPreloader.fadeOut(100);
				showingT = setTimeout(function(){resizeAndShow(tW, tH)},300);
			
			}).error(function(){
			
			}).attr('src',path);
		
		}
		
		function resizeAndShow(imgWidth, imgHeight){
			
			//get maximum stretch area
			if(!o.imageResize){
				var sW = imgWidth;
				var sH = imgHeight;
			}else{
				if((tW < tH && ($w.height()-200 < tH || $w.width()-100 < tW)) || (tW > tH && ($w.height()-200 < tH || $w.width()-100 < tW))){
					var sW = $w.width()-100;
					var sH = $w.height()-200;
				} else {
					var sW=imgWidth;
					var sH=imgHeight;
				}
			}
			
			//get new size values
			var nW = scaleSize(sW, sH, imgWidth, imgHeight, 'in')[0];
			var nH = scaleSize(sW, sH, imgWidth, imgHeight, 'in')[1];
			
			//animate holder, show preloader, resize image and fade it in
			if($imgFrame.width() == nW && $imgFrame.height() == nH){
				var fadeDelay=0;
				eM=true;
			}else{
				var fadeDelay=300;
				$imgFrame.stop().animate({
					width:nW, 
					height:nH,
					'top':($w.height()-nH)/2,
					'left':($w.width()-nW)/2
					}, 300 ,function(){
						eM=true;
				});
			}
			
			$imgPreloader.width(nW).height(nH);
			
			$imgHolder.width(nW).height(nH).delay(fadeDelay).fadeIn(function(){
				
				//continue slideshow
				if(showOn){
					showT=setTimeout(nextImage, o.slideshowTimer);
					$showAnim.animate({height: 31}, o.slideshowTimer, "linear");
				}
				
				if(o.captionsEnabled){
					showText();
				}
			
			});
			
		}
		
		//function that shows the text
		function showText(){
			$boxText.css('width',$imgFrame.width())
				.css('top', $imgFrame.offset().top-$boxText.height()+5-tS).css('left', $imgFrame.offset().left-lS)
				.fadeIn();
		}
		
		//function that calculates the size of an image(proportionally resized) based on the given parameters
		function scaleSize(maxW, maxH, currW, currH, direction){
		
			var w = maxW;
			var h = maxH;

			var spriteRatio=w/h;
			var ratio=currW/currH;

			if(direction=='in'){
			
				if (ratio<spriteRatio) {
					w=h*ratio;
				}
				if (ratio>spriteRatio) {
					h=w/ratio;
				}
			
			}else{

				if (ratio>spriteRatio) {
					w=h*ratio;
				}
				if (ratio<spriteRatio) {
					h=w/ratio;
				}
			
			}
			
			return [w, h];
			
		}
		
		//function that shows the next image
		function nextImage(){
		
			eM=false;
			if(++gIndex>=gLength){
				gIndex=0;
			}
			changeImage();
		
		}
		
		//function that shows the previous image
		function prevImage(){
		
			eM=false;
			if(--gIndex<0){
				gIndex=gLength-1;
			}
			changeImage();
			
		}
		
		var dC=false;
		//function that changes the current image
		function changeImage(kwicked) {
		
			if(!kwicked){
				dC=true;
				if(o.thumbsEnabled){
					$boxThumbs.eq(gIndex).trigger('click');
				}
			}
		
			$showAnim.stop().animate({height: 0}, 100);
			
			clearTimeout(showT);
			clearTimeout(loadingT);
			
			$boxText.stop().fadeOut('fast');
			
			$imgHolder.stop().fadeOut('fast', function(){
			
				$imgPreloader.fadeIn('fast');
				$imgHolder.remove();
			
				//change text
				if(o.captionsEnabled){
					changeText();
				}
			
				//load the new image
				var path=$gThumbs.eq(gIndex).parent().attr('href').toString();
		
				loadingT=setTimeout(function(){loadImage(path)},100);
				
			});
			
		
		}
		
		//function that changes the text
		function changeText(){
			var txtString = '<p>'
			if($gThumbs.eq(gIndex).attr('title')!=null) {
				txtString += '<span>'+$gThumbs.eq(gIndex).attr('title').toString()+'</span><br/>';
			}
			if($gThumbs.eq(gIndex).attr('alt')!=null) {
				txtString += $gThumbs.eq(gIndex).attr('alt');
			}
			txtString += '</p>';
			if(txtString != '<p></p>'){
				$boxText.html(txtString);
			}
		}

		function resizeStage() {
		
			if(!o.imageResize){
				var sW=tW;
				var sH=tH;
			}else{
				if((tW < tH && ($w.height()-200 < tH || $w.width()-100 < tW)) || (tW > tH && ($w.height()-200 < tH || $w.width()-100 < tW))){
					var sW = $w.width()-100;
					var sH = $w.height()-200;
				} else {
					var sW=tW;
					var sH=tH;
				}
			}
				
			tS = $w.scrollTop();
			lS = $w.scrollLeft();
				
			if(sW>480 && sH>360){
			
				var nW = scaleSize(sW, sH, $imgFrame.width(), $imgFrame.height(), 'in')[0];
				var nH = scaleSize(sW, sH, $imgFrame.width(), $imgFrame.height(), 'in')[1];
				
				$imgFrame.width(nW).height(nH)
					.css('top', ($w.height()-nH)/2)
					.css('left', ($w.width()-nW)/2);
				
				$imgHolder.width(nW).height(nH);
					
				$boxText.css('width',$imgFrame.width())
					.css('top', $imgFrame.offset().top-$boxText.height()+5-tS)
					.css('left', $imgFrame.offset().left-lS);
			
			}
			
		}		
		
		function playSlideshow(){
		
			showOn=true;
			showT=setTimeout(nextImage, o.slideshowTimer);
			
			$bPlay.hide();
			$bPause.show();
			$showAnim.animate({height: 31}, o.slideshowTimer, "linear");
			
		}
		
		function pauseSlideshow(){
		
			showOn=false;
			clearTimeout(showT);
			
			$bPlay.show();
			$bPause.hide();
			$showAnim.stop().animate({height: 0}, 100);

		}
		
		//minimy thumbs functions - kwicks plugin
		function kwicks(options){
		
			var defaults = {
				isVertical: false,
				sticky: true,
				defaultKwick: 0,
				event: 'click',
				spacing: 0,
				duration: 300,
				min:8,
				max:41
			};
			
			var o = $.extend(defaults, options);
			var WoH = (o.isVertical ? 'height' : 'width'); // WoH = Width or Height
			var LoT = (o.isVertical ? 'top' : 'left'); // LoT = Left or Top
		
			var container = $boxThumbsList;
			var kwicks = container.children('li');
			var normWoH = kwicks.eq(0).css(WoH).replace(/px/,''); // normWoH = Normal Width or Height
			// set width of container ul
			container.css({
				width: (33+kwicks.size()*8) + 'px',
				height : kwicks.eq(0).css('height')
			});

			// pre calculate left or top values for all kwicks but the first and last
			// i = index of currently hovered kwick, j = index of kwick we're calculating
			var preCalcLoTs = []; // preCalcLoTs = pre-calculated Left or Top's
			for(i = 0; i < kwicks.size(); i++) {
				preCalcLoTs[i] = [];
				// don't need to calculate values for first or last kwick
				for(j = 1; j < kwicks.size() - 1; j++) {
					if(i == j) {
						preCalcLoTs[i][j] = o.isVertical ? j * o.min + (j * o.spacing) : j * o.min + (j * o.spacing);
					} else {
						preCalcLoTs[i][j] = (j <= i ? (j * o.min) : (j-1) * o.min + o.max) + (j * o.spacing);
					}
				}
			}
			
			// loop through all kwick elements
			kwicks.each(function(i) {
				var kwick = $(this);
				// set initial width or height and left or top values
				// set first kwick
				if(i === 0) {
					kwick.css(LoT, '0px');
				} 
				// set last kwick
				else if(i == kwicks.size() - 1) {
					kwick.css(o.isVertical ? 'bottom' : 'right', '0px');
				}
				// set all other kwicks
				else {
					kwick.css(LoT, preCalcLoTs[o.defaultKwick][i]);
				}
				// correct size in sticky mode
				if(o.defaultKwick == i) {
					kwick.css(WoH, o.max + 'px').css('opacity', 1).addClass('active');
				} else {
					kwick.css(WoH, o.min + 'px');
				}
				kwick.css({
					margin: 0,
					position: 'absolute'
				});

				//kwick events
				kwick.bind('mouseover', function(){
					kwick.animate({'opacity':1},200);
					return false;
				}).bind('mouseleave', function(){
					if(!kwick.hasClass('active')){
						kwick.animate({'opacity':.2}, 200);
					}
					return false;
				}).bind(o.event, function() {
					if(eM || dC){
					
						eM=false;
						if(!kwick.hasClass('active')){
							// calculate previous width or heights and left or top values
							var prevWoHs = []; // prevWoHs = previous Widths or Heights
							var prevLoTs = []; // prevLoTs = previous Left or Tops
							kwicks.stop();
							for(j = 0; j < kwicks.size(); j++) {
								prevWoHs[j] = kwicks.eq(j).css(WoH).replace(/px/, '');
								prevLoTs[j] = kwicks.eq(j).css(LoT).replace(/px/, '');
								if(kwicks.eq(j).hasClass('active')){
									kwicks.eq(j).removeClass('active').animate({'opacity':.2}, 200);
								}
							}
							var aniObj = {'opacity':1};
							aniObj[WoH] = o.max;
							var maxDif = o.max - prevWoHs[i];
							var prevWoHsMaxDifRatio = prevWoHs[i]/maxDif;
							kwick.addClass('active').animate(aniObj, {
								step: function(now) {
									// calculate animation completeness as percentage
									var percentage = maxDif != 0 ? now/maxDif - prevWoHsMaxDifRatio : 1;
									// adjsut other elements based on percentage
									kwicks.each(function(j) {
										if(j != i) {
											kwicks.eq(j).css(WoH, Math.ceil(prevWoHs[j] - ((prevWoHs[j] - o.min) * percentage)) + 'px');
										}
										if(j > 0 && j < kwicks.size() - 1) { // if not the first or last kwick
											kwicks.eq(j).css(LoT, Math.ceil(prevLoTs[j] - ((prevLoTs[j] - preCalcLoTs[i][j]) * percentage)) + 'px');
										}
									});
								},
								duration: o.duration,
								easing: o.easing
							});
							
							if(!dC){
								gIndex=kwick.index();
								changeImage(true);
							}
							dC=false;
						
						}
					
						return false;
						
					}
				});
			});
			
		}
		
		//function that closes the lightbox
		function closeLightBox(){
		
			//cancel any loading in progress
			if(imageLoading){
				imageLoading = false;
				$(globalImage).attr('src', '');
			}
		
			//unbind all mouse and stage events
			$bNext.unbind('click').unbind('mouseover').unbind('mouseleave');
			$bPrev.unbind('click').unbind('mouseover').unbind('mouseleave');
			$bClose.unbind('click').unbind('mouseover').unbind('mouseleave');
			$bPlay.unbind('click').unbind('mouseover').unbind('mouseleave');
			$bPause.unbind('click');
			$(window).unbind('resize');
			$imgFrame.unbind('click');
			$(document).unbind('keypress');

			if(o.thumbsEnabled){
			//unbind all kwicks events
				$boxThumbs.each(function(i){
					$boxThumbs.eq(i).unbind('click').unbind('mouseover').unbind('mouseleave');
				});
			}
			
			//clear timeouts
			clearTimeout(loadingT);
			clearTimeout(showT);

			//stop all animations
			$imgFrame.stop();
			if($imgHolder != undefined && $imgHolder != null) $imgHolder.stop();
			$imgPreloader.stop();
			$showAnim.stop();
			$boxText.stop();

			//animate everything "out", remove the lightbox completely from the stage and set the overflow back
			$boxText.fadeOut(150);
			$imgPreloader.fadeOut(100);
			if($imgHolder != undefined && $imgHolder != null) $imgHolder.fadeOut(150);
			$boxMenu.fadeOut(150, function(){
				$imgFrame.stop().animate({height:'0px'},300,'easeInQuart',function(){
					$boxBackground.stop().animate({height:'0%'},250,'easeOutQuart',function(){
						$('div#minimy').remove();
						$html.css('overflow', oF);
					});
				});
			});
			
		}
		
		//gallery thumbnails scroll events
		function scrollNext(){
			if(gPage+1<gPages && eS){
			
				eS=false;
				gPage++;
				
				for(var i=0; i<gLength; i++){
				
					if(gPage==gPages-1){
						var nX=(parseInt($gThumbsList.children().eq(i).css('left'))-o.thumbsWidth*tOnLast);
					}else{
						var nX=(parseInt($gThumbsList.children().eq(i).css('left'))-o.thumbsWidth*o.thumbsPerPage);
					}
					
					if(i==gLength-1){
						$gThumbsList.children().eq(i).delay(i*20).animate({left: nX}, function(){
							eSF();
						});
					}else{
						$gThumbsList.children().eq(i).delay(i*20).animate({left: nX});
					}
					
				}
				
			}
		}
		
		function scrollPrev(){
			if(gPage>0 && eS){
			
				eS=false;
				gPage--;
				
				for(var i=0; i<gLength; i++){
				
					if(gPage==gPages-2){
						var nX=(parseInt($gThumbsList.children().eq(i).css('left'))+o.thumbsWidth*tOnLast);
					}else{
						var nX=(parseInt($gThumbsList.children().eq(i).css('left'))+o.thumbsWidth*o.thumbsPerPage);
					}
					
					if(i==0){
						$gThumbsList.children().eq(i).delay((gLength-i)*20).animate({left: nX}, function(){
							eSF();
						});
					}else{
						$gThumbsList.children().eq(i).delay((gLength-i)*20).animate({left: nX});
					}
					
				}
				
			}
		}
		
		function eSF(){
			eS=true;
		}
		
	}

})(jQuery);

//jQuery easing functions(only the used ones)
jQuery.extend(jQuery.easing,
{
	def: 'easeInOutSine',
    easeInOutSine: function (x, t, b, c, d) {
        return -c/2 * (Math.cos(Math.PI*t/d) - 1) + b;
    },
	easeInQuart: function (x, t, b, c, d) {
		return c*(t/=d)*t*t*t + b;
	},
	easeOutQuart: function (x, t, b, c, d) {
		return -c * ((t=t/d-1)*t*t*t - 1) + b;
	},
	easeOutCirc: function (x, t, b, c, d) {
		return c * Math.sqrt(1 - (t=t/d-1)*t) + b;
	}
});